function [r]=avgr4pts(XY,p)
% [x,y,r]=avgr4pts(XY) Find the average center and radius for 4pts, using
% the 4 circles that can be formed.
if nargin==1
    p=0;
end
if length(XY)~=4
    error('There need to be FOUR points')
end
%Four permutations
[xd(1),yd(1),rd(1)]=circ3ptsc([[XY(1,1);XY(2,1);XY(3,1)] , [XY(1,2);XY(2,2);XY(3,2)]]);    %1,2,3
[xd(2),yd(2),rd(2)]=circ3ptsc([[XY(1,1);XY(2,1);XY(4,1)] , [XY(1,2);XY(2,2);XY(4,2)]]);    %1,2,4
[xd(3),yd(3),rd(3)]=circ3ptsc([[XY(1,1);XY(3,1);XY(4,1)] , [XY(1,2);XY(3,2);XY(4,2)]]);    %1,3,4
[xd(4),yd(4),rd(4)]=circ3ptsc([[XY(2,1);XY(3,1);XY(4,1)] , [XY(2,2);XY(3,2);XY(4,2)]]);    %2,3,4
%Average
x=mean(xd);
y=mean(yd);
r=mean(rd);
%Standard deviation
stdx=std(xd);
stdy=std(yd);
stdr=std(rd);

if p~=0
%Plot the points and the circle
t=0:0.01:2*pi;
xp=x+r*cos(t);
yp=y+r*sin(t);
figure, plot(XY(:,1),XY(:,2),'rx',xp,yp)
title(['Avg circle radius for 4 points - \newline(R1:' num2str(rd(1)) ', R2:' num2str(rd(2)) ', R3:' num2str(rd(3)) ', R4:' num2str(rd(4)) ', AVG:' num2str(r) ')'])
end
