function [x,y,r]=circ3ptsc(XY)
%CIRC3PTSc will calculate a circle based on 3 pts.  This functions uses
%equations derived from the intersection of perdendicular bisectors of 2
%chords of the circle.
% A. McClung 02/21/03
% NOTE:Currently, this may fail for horizontal points -2/21/03
if nargin~=1
    err('X and Y coordinates are needed in one matrix!')
else
    if (prod(size(XY))~=6)&(length(XY)~=3)
        err('Three X and Y coordinates are needed (3x2 or 2x3)')
    end
end
if size(XY)==[2 3]
    XY=XY'
end
%Convenient variables
x1=XY(1,1);
x2=XY(2,1);
x3=XY(3,1);
y1=XY(1,2);
y2=XY(2,2);
y3=XY(3,2);
%Chord midpoints
xa=(x1+x2)/2;
ya=(y1+y2)/2;
xb=(x2+x3)/2;
yb=(y2+y3)/2;
%Perpendicular bisector slope
if y2==y1
    ba=1;
%    ca=0;
%    wa=xa;
else
    ba=-(x2-x1)/(y2-y1);
%    ca=-1;
%    wa=bb*xb-yb;
end
if y3==y2
    bb=1;
%    cb=0;
%    wb=xb;
else
    bb=-(x3-x2)/(y3-y2);
%    cb=-1;
%    wb=ba*xa-ya;
end
%Calculate circle center
x=(yb-ya+ba*xa-bb*xb)/(ba-bb);
y=ya+ba*(x-xa);
%A=[ba ca;bb cb];
%w=[wa;wb];
%[xy]=inv(A)*w;
%x=xy(1);
%y=xy(2);
%Calculate radius
r=sqrt((x-x1)^2+(y-y1)^2);

clear x1 x2 x3 y1 y2 y3
clear xp yp
